searchNodes=[{"doc":"BORSH, binary serializer for security-critical projects. Borsh stands for &quot;Binary Object Representation Serializer for Hashing&quot;. It is meant to be used in security-critical projects as it prioritizes consistency, safety, speed; and comes with a strict specification. In short, Borsh is a non self-describing binary serialization format. It is designed to serialize any objects to canonical and deterministic set of bytes. General principles of Borsh serialization: Integers are encoded in little-endian format. The size of dynamic containers (such as hash maps and hash sets) is written as a 32-bit unsigned integer before the values. All unordered containers are ordered lexicographically by key, with a tie breaker of the value. Structs are serialized in the order of their fields. Enums are serialized by storing the ordinal as an 8-bit unsigned integer, followed by the data contained within the enum value (if present). This is Elixir implementation of the Borsh serializer and deserializer. Official specification: https://github.com/near/borsh#specification Usage use Borsh , schema : [ signer_id : :string , public_key : :borsh , nonce : :u64 , receiver_id : :string , block_hash : [ 32 ] , actions : [ :borsh ] ] Options schema : Borsh schema itself, structure of fields for serialisation with serialisation formats. Borsh literal formats :string - the type represents the string representation of a value. When using the Borsh serialization format, it is encoded as-is, with a 4-byte little-endian header indicating the number of bytes in the string. :borsh - Struct of the borsh-ed module. The serializer will take this struct and executes struct's module .borsh_encode against this struct and assign binary result to the literal. [:borsh] - Enum of borsh-ed structs. Each element of this list of :borsh struct must have a Borsh schema :u64 - Unsigned integer 64-bit size. There are also :u8 , :u16 , :u32 and :u128 [32] or [64] - A string with 32/64 chars length.","ref":"Borsh.html","title":"Borsh","type":"module"},{"doc":"The Borsh.Decode module provides functions for decoding data serialized using the Borsh format. It defines functions for each supported data type (e.g. :string , :u8 , :i64 ) that can be used to decode a value of that type from a given bitstring. The primary function in this module is borsh_decode , which takes a bitstring and the name of a Borsh-serialized module as arguments. It retrieves the schema for the module and uses it to decode the data contained in the bitstring. The resulting data is returned as a struct of the module. Usage As an example let's use the following struct previuosly serialised into borsh bitstring. defmodule ParentStruct do @type t ( ) :: % __MODULE__ { first_name : String . t ( ) , last_name : String . t ( ) , age : integer } defstruct [ :first_name , :last_name , :age ] use Borsh , schema : [ first_name : :string , last_name : :string , age : :u8 ] end To use the Borsh.Decode module, you can pass a bitstring and the name of a Borsh-serialized struct to the borsh_decode function. For example: bitstr = &lt;&lt; 5 , 0 , 0 , 0 , 66 , 111 , 114 , 105 , 115 , 7 , 0 , 0 , 0 , 74 , 111 , 104 , 110 , 115 , 111 , 110 , 58 &gt;&gt; Borsh.Decode . borsh_decode ( bitstr , ParentStruct ) % ParentStruct { first_name : &quot;Boris&quot; , last_name : &quot;Johnson&quot; , age : 58 }","ref":"Borsh.Decode.html","title":"Borsh.Decode","type":"module"},{"doc":"Decodes objects according to the schema into the the struct","ref":"Borsh.Decode.html#borsh_decode/2","title":"Borsh.Decode.borsh_decode/2","type":"function"},{"doc":"This module contains functions for encoding Elixir data structures into BORSH binary format. Usage defmodule ParentStruct do @type t ( ) :: % __MODULE__ { first_name : String . t ( ) , last_name : String . t ( ) , age : integer } defstruct [ :first_name , :last_name , :age ] use Borsh , schema : [ first_name : :string , last_name : :string , age : :u8 ] end borsh_struct = % ParentStruct { first_name : &quot;Boris&quot; , last_name : &quot;Johnson&quot; , age : 58 } Borsh.Encode . encode ( borsh_struct ) &lt;&lt; 5 , 0 , 0 , 0 , 66 , 111 , 114 , 105 , 115 , 7 , 0 , 0 , 0 , 74 , 111 , 104 , 110 , 115 , 111 , 110 , 58 &gt;&gt;","ref":"Borsh.Encode.html","title":"Borsh.Encode","type":"module"},{"doc":"Encodes structs according to the schema into the bitstring","ref":"Borsh.Encode.html#borsh_encode/1","title":"Borsh.Encode.borsh_encode/1","type":"function"},{"doc":"","ref":"Borsh.Encode.html#convert_size/1","title":"Borsh.Encode.convert_size/1","type":"function"}]